<?php
/***************************************************************************
 *                           inline_install.php
 *                            -------------------
 *   begin                : Tuesday, Nov 8, 2005
 *   copyright            : (C) 2005 geocator (www.geocator.us)
 *   email                : geocator@gmail.com
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
//lang entries used in this file
$install_lang['wrong_directory'] = 'You must place this file in your phpBB root directory';
$install_lang['Title'] = 'Installing Inline Banner Ads';
$install_lang['wait'] = 'Please wait until all steps are done and you recieve a message that says "Installation Complete"';
$install_lang['action_1'] = 'Creating Ad Table: ';
$install_lang['action_2'] = 'Updating Ad Table: ';
$install_lang['action_3'] = 'Adding New Config Values: ';
$install_lang['failed'] = 'Failed';
$install_lang['success'] = 'Success';
$install_lang['install_complete'] = 'Installation Complete please delete this file from your server now.';
$install_lang['install_complete_errors'] = 'Installation Complete However there where some errors, you need to run the following sql queries manually.';
$install_lang['make_changes'] = 'You must make all the MOD code changes before running this install';
$install_lang['already_run'] = 'You have already run this install, please delete the file now.';


//Attempt to kill the php time limit
@set_time_limit(0);

//To be friendly lets make sure this file is in the right place
if(!@file_exists('config.php'))
{
	die($install_lang['wrong_directory']);
}


define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$errors = array();
$error_count = 0;

//Make sure MOD code already installed
confirm_code_changes();

//Install database components.  Should work on all supported db types, but no guarantees.
echo ('<h3>' . $install_lang['Title'] . '</h3>');
echo ($install_lang['wait'] . '<br /><br />');

//Create Ad table
echo ($install_lang['action_1']);
$sql = "CREATE TABLE " . ADS_TABLE . " (
		ad_id TINYINT( 5 ) NOT NULL auto_increment,
		ad_code TEXT NOT NULL ,
		ad_name CHAR( 25 ) NOT NULL,
		PRIMARY KEY (ad_id)
		)";
if (!$db->sql_query($sql))
{
	$errors[$error_count] = $sql;
	$error_count = $error_count + 1;
	
	echo ('<font color="red">' . $install_lang['failed'] .'</font>');
} 
else 
{
	echo ('<font color="green">' . $install_lang['success'] . '</font>');
}
echo ('<br /><br />');

//Populate ad table with defualt data
echo ($install_lang['action_2']);
$sql = "INSERT INTO " . ADS_TABLE . " (ad_id , ad_code, ad_name )
		VALUES (1, 'Your banner code goes here', 'Default')";
if (!$db->sql_query($sql))
{
	$errors[$error_count] = $sql;
	$error_count = $error_count + 1;
	
	echo ('<font color="red">' . $install_lang['failed'] .'</font>');
} 
else 
{
	echo ('<font color="green">' . $install_lang['success'] . '</font>');
}
echo ('<br /><br />');

//Add new config values
echo ($install_lang['action_3']);
$sql = 'INSERT INTO ' . CONFIG_TABLE . " (config_name, config_value) VALUES 
										('ad_after_post', '1'),
										('ad_post_threshold', ''),
										('ad_every_post', ''),
										('ad_who', '1'),
										('ad_no_forums', ''),
										('ad_no_groups', ''),
										('ad_old_style', '1')";
if (!$db->sql_query($sql))
{
	$errors[$error_count] = $sql;
	$error_count = $error_count + 1;
	
	echo ('<font color="red">' . $install_lang['failed'] .'</font>');
} 
else 
{
	echo ('<font color="green">' . $install_lang['success'] . '</font>');
}
echo ('<br /><br />');


//Where there any errors?
if ( $error_count == 0 )
{
	echo ('<font color="green">' . $install_lang['install_complete'] . '</font>');
}
else 
{
	echo ('<font color="red">' . $install_lang['install_complete_errors'] . '</font><br /><br />');
	for ( $i=0; $i<$error_count; $i++ )
	{
		echo ($errors[$i] . ';<br /><br />');
	}
}


function confirm_code_changes()
{
	global $board_config, $install_lang;
	
	//The main issue to the installer running is the table constants being defined
	if ( !defined('ADS_TABLE') )
	{
		message_die(GENERAL_ERROR, $install_lang['make_changes']);
	}
	if ( isset($board_config['ad_after_post']) )
	{
		message_die(GENERAL_ERROR, $install_lang['already_run']);
	}
}

?>